//+------------------------------------------------------------------+
//|                                                          WPR.mq5 |
//|                                Copyright 2021, Andrei Novichkov. |
//|                                              https://fxstill.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Andrei Novichkov."
#property link      "https://fxstill.com"
#property version   "1.00"

#property indicator_separate_window

#property indicator_buffers 1
#property indicator_plots   1

#include "Controller\Controller.mqh"



CController* pController;

int OnInit() {
   pController = new CController();
   return pController.Initialize();
}

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]) {

   return pController.Tick(rates_total, prev_calculated, time, open, high, low, close, tick_volume, volume, spread);

}

void OnDeinit(const int  reason) {
   if (CheckPointer(pController) != POINTER_INVALID) 
      delete pController;
}

void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
      pController.ChartEvent(id, lparam, dparam, sparam);
  }